// ABDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ABReturn.h"
#include "ABDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ABDialog dialog


ABDialog::ABDialog(CWnd* pParent /*=NULL*/)
	: CDialog(ABDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(ABDialog)
	m_AN8 = _T("");
	m_ALPH = _T("");
	//}}AFX_DATA_INIT

}


void ABDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ABDialog)
	DDX_Text(pDX, IDC_EDIT_AN8, m_AN8);
	DDV_MaxChars(pDX, m_AN8, 8);
	DDX_Text(pDX, IDC_EDIT_ALPH, m_ALPH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ABDialog, CDialog)
	//{{AFX_MSG_MAP(ABDialog)
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnButtonFind)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ABDialog message handlers

void ABDialog::OnButtonFind() 
{
  /************************************************************************
   * Data Structures & Pointers
   ************************************************************************/

	ID			idReturnValue		= ER_SUCCESS;
	ID			idJDEDBReturn		= JDEDB_PASSED;
	ID			idErrorFlag 		= ER_SUCCESS;
    HUSER		hUser				= (HUSER)NULL;
    HREQUEST hRequest				= (HREQUEST)NULL;

  	NID			szTableID			= NID_F0101;
	ID			idIndexID			= ID_F0101_ADDRESS;

    F0101         dsF0101;
    KEY1_F0101    dsF0101Key1;

  /************************************************************************
   * Main Processing
   ************************************************************************/

   // Initialize hUser and Return if this fails
   idJDEDBReturn = JDB_InitBhvr((void *)lpBhvrCom, &hUser, (char *) NULL, JDEDB_COMMIT_AUTO);
	
	if (idJDEDBReturn != JDEDB_PASSED)
   {
      return;
   }

	// Read the Screen
	UpdateData();

	//
	// Open the Address Book File
	//
    idJDEDBReturn = JDB_OpenTable(hUser,szTableID,idIndexID,0,
                                (unsigned short)0,(char *) NULL,
                                &hRequest);

	// Prepare the Key and Return Structure
	memset((void *)&dsF0101,(int)'\0',sizeof(F0101));
	memset((void *)&dsF0101Key1,(int)'\0',sizeof(KEY1_F0101));

    ParseNumericString(&dsF0101Key1.aban8,(char*)(LPCTSTR) m_AN8);

	// Fetch the Record
	idJDEDBReturn = JDB_FetchKeyed(hRequest,(ID)0,
                                 (void *)&dsF0101Key1,
                                 (unsigned short)1,(LPVOID)&dsF0101,
                                 (int)FALSE);

	if (idJDEDBReturn != JDEDB_PASSED)
	{
		// Nothing was found, blank out the result field
		m_ALPH=" ";
	}
	else
	{
		// A record was found, place ALPH onto the dialog
		// Also, fill the lpDS to pass results back to calling program
		m_ALPH.Format("%s",dsF0101.abalph);
		sprintf(lpDS->szNameAlpha,"%s",dsF0101.abalph);
		ParseNumericString(&lpDS->mnAddressNumber,(char*)(LPCTSTR) m_AN8);
	}

	// Update the Screen
	UpdateData(FALSE);

	// Close the table and free the hUser.	
	JDB_CloseTable (hRequest);
	JDB_FreeBhvr(hUser);

	return;

}
